## wargus-2.4.1.tar.gz

=== CMakeLists.txt ===
#       _________ __                 __
#      /   _____//  |_____________ _/  |______     ____  __ __  ______
#      \_____  \\   __\_  __ \__  \\   __\__  \   / ___\|  |  \/  ___/
#      /        \|  |  |  | \// __ \|  |  / __ \_/ /_/  >  |  /\___ |
#     /_______  /|__|  |__|  (____  /__| (____  /\___  /|____//____  >
#             \/                  \/          \//_____/            \/
#  ______________________                           ______________________
#                        T H E   W A R   B E G I N S
#         Stratagus - A free fantasy real time strategy game engine
#
#    CMakeLists.txt
#    Copyright (C) 2011-2015  Pali Rohár <pali.rohar@gmail.com>
#                             cybermind <cybermindid@gmail.com>
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#

project(wargus)
cmake_minimum_required(VERSION 2.6)
set(WARGUS_VERSION 2.4.1)

# Wargus sources

set(pudconvert_SRCS
	pud.cpp
	pudconvert.cpp
)

set(pudconvert_HDRS
	endian.h
	pud.h
)

set(wartool_SRCS
	pud.cpp
	wartool.cpp
	xmi2mid.cpp
)

set(wartool_HDRS
	wartool.h
	endian.h
	pud.h
	xmi2mid.h
)

set(wargus_SRCS
	wargus.cpp
)

if(WIN32)
	set(wargus_SRCS
		${wargus_SRCS}
		wargus.rc
	)
	set(wartool_SRCS
		${wartool_SRCS}
		rip_music_win32.cpp
	)
else()
	set(wartool_SRCS
		${wartool_SRCS}
		rip_music_unix.cpp
	)
endif()

set(warextract_SRCS
	warextract.c
)

# Additional platform checks
if(NOT (WIN32 AND MSVC))
	find_package(PkgConfig QUIET REQUIRED)
endif()

# Find all libraries

option(ENABLE_STATIC "Compile Wargus binaries as static executable" OFF)

if(ENABLE_STATIC)
	set(CMAKE_FIND_LIBRARY_SUFFIXES ".lib;.a")
endif()

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules ${CMAKE_MODULE_PATH})

find_package(Stratagus)
if(NOT STRATAGUS_FOUND)
	# Just means we won't build the launcher ...
	set(STRATAGUS_INCLUDE_DIR ".")
endif()

find_package(PNG REQUIRED)
find_package(ZLIB REQUIRED)
find_package(StormLib)

if(WIN32)
	find_package(MakeNSIS)
endif()

if(NOT WIN32)
	find_package(X11 REQUIRED)
	find_package(GTK2 REQUIRED gtk)
	if (NOT GTK2_FOUND)
	  add_definitions("-DNOGTK")
	endif()
endif()

find_package(SelfPackers)

# Windows RC compiler definitions

if(WIN32)
	enable_language(RC)
	include(CMakeDetermineRCCompiler)

	if(MINGW)
		set(CMAKE_RC_COMPILER_INIT windres)
		set(CMAKE_RC_COMPILE_OBJECT "<CMAKE_RC_COMPILER> <FLAGS> -O coff <DEFINES> -i <SOURCE> -o <OBJECT>")
	endif()
endif()

# Options for compiling

if(WIN32)
	option(ENABLE_NSIS "Create Stratagus Window NSIS Installer" OFF)
endif()

option(ENABLE_UPX "Compress Stratagus executable binary with UPX packer" OFF)
option(ENABLE_STRIP "Strip all symbols from executables" OFF)

option(WITH_STORMLIB "Compile wartool with StormLib support" ON)

# Install paths
set(BINDIR "bin" CACHE PATH "Where to install user binaries")
set(GAMEDIR "games" CACHE PATH "Where to install games binaries")
set(SHAREDIR "share/games/stratagus/wargus" CACHE PATH "Where to install data files")
set(DATAROOTDIR "${CMAKE_INSTALL_PREFIX}/share" CACHE PATH "Sets the root of data directories to a non-default location")
set(ICONDIR "${DATAROOTDIR}/pixmaps" CACHE PATH "Sets the icon directory for desktop entry to a non-default location.")
set(DESKTOPDIR "${DATAROOTDIR}/applications" CACHE PATH "Sets the desktop file directory for desktop entry to a non-default location.")

if(NOT IS_ABSOLUTE "${GAMEDIR}")
	set(GAMEDIRABS "${CMAKE_INSTALL_PREFIX}/${GAMEDIR}")
else()
	set(GAMEDIRABS "${GAMEDIR}")
endif()

# Wargus definitions

add_definitions(${PNG_DEFINITIONS})
include_directories(${PNG_INCLUDE_DIR} ${ZLIB_INCLUDE_DIRS} ${STRATAGUS_INCLUDE_DIR})
set(pudconvert_LIBS ${pudconvert_LIBS} ${ZLIB_LIBRARIES})
set(wartool_LIBS ${pudconvert_LIBS} ${PNG_LIBRARIES} ${ZLIB_LIBRARIES})

# Platform definitions

if (WIN32 AND MSVC)
	add_definitions(-D_CRT_SECURE_NO_WARNINGS -D_CRT_SECURE_NO_DEPRECATE=1)
endif()

if(NOT WIN32)
	include_directories(${X11_INCLUDE_DIR} ${GTK2_INCLUDE_DIRS})
	set(wargus_LIBS ${wargus_LIBS} ${X11_X11_LIB} ${GTK2_LIBRARIES})
endif()

if (NOT WIN32)
	if(NOT IS_ABSOLUTE "${SHAREDIR}")
		set(DATA_PATH "${CMAKE_INSTALL_PREFIX}/${SHAREDIR}")
	else()
		set(DATA_PATH "${SHAREDIR}")
	endif()
	add_definitions(-DDATA_PATH="${DATA_PATH}")
	add_definitions(-DSCRIPTS_PATH="${DATA_PATH}")
	add_definitions(-DSTRATAGUS_BIN="${STRATAGUS}")
endif()

if(ENABLE_STRIP)
	set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -s")
endif()

# For now, doesn't compile on OS X with StormLib
if(WITH_STORMLIB AND STORMLIB_FOUND)
	add_definitions(-DUSE_STORMLIB -D__STORMLIB_SELF__)
	include_directories(${STORMLIB_INCLUDE_DIR})
	set(wartool_LIBS ${wartool_LIBS} ${STORMLIB_LIBRARY} ${BZIP2_LIBRARIES})
endif()

# Compile Wargus

add_executable(pudconvert ${pudconvert_SRCS} ${pudconvert_HDRS})
target_link_libraries(pudconvert ${pudconvert_LIBS})

if(STRATAGUS_FOUND)
	add_executable(wargus WIN32 ${wargus_SRCS} ${wargus_HDRS})
	target_link_libraries(wargus ${wargus_LIBS})
endif()

add_executable(wartool ${wartool_SRCS} ${wartool_HDRS})
target_link_libraries(wartool ${wartool_LIBS})

if(WIN32 AND MINGW AND ENABLE_STATIC)
	set_target_properties(pudconvert PROPERTIES LINK_FLAGS "${LINK_FLAGS} -static-libgcc -static-libstdc++")
	set_target_properties(wargus PROPERTIES LINK_FLAGS "${LINK_FLAGS} -static-libgcc -static-libstdc++")
	set_target_properties(wartool PROPERTIES LINK_FLAGS "${LINK_FLAGS} -static-libgcc -static-libstdc++")
endif()

########### next target ###############

macro(self_packer PACKER_TARGET)
	get_target_property(PACKER_NAME ${PACKER_TARGET} OUTPUT_NAME)
	if(NOT PACKER_NAME)
		set(PACKER_NAME ${PACKER_TARGET})
	endif()
	add_custom_command(TARGET ${PACKER_TARGET} POST_BUILD
		COMMAND ${SELF_PACKER_FOR_EXECUTABLE}
		ARGS ${SELF_PACKER_FOR_EXECUTABLE_FLAGS} ${PACKER_NAME}${CMAKE_EXECUTABLE_SUFFIX}
	)
endmacro()

if(ENABLE_UPX AND SELF_PACKER_FOR_EXECUTABLE)
	self_packer(pudconvert)
	self_packer(wargus)
	self_packer(wartool)
endif()

########### next target ###############

if(WIN32 AND ENABLE_NSIS AND MAKENSIS_FOUND)
	file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/COPYING DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
	file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/COPYING-3rd DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
	file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/wargus.ico DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
	add_custom_command(OUTPUT Wargus-${WARGUS_VERSION}${MAKENSIS_SUFFIX}
		COMMAND ${MAKENSIS}
		ARGS ${MAKENSIS_FLAGS} -DCMAKE_CURRENT_SOURCE_DIR="${CMAKE_CURRENT_SOURCE_DIR}" -DCMAKE_CURRENT_BINARY_DIR="${CMAKE_CURRENT_BINARY_DIR}" ${CMAKE_CURRENT_SOURCE_DIR}/wargus.nsi
		DEPENDS wargus.nsi pudconvert wargus wartool COPYING COPYING-3rd wargus.ico
		COMMENT "Generating Wargus Windows NSIS Installer" VERBATIM
	)
	add_custom_target(nsis ALL DEPENDS Wargus-${WARGUS_VERSION}${MAKENSIS_SUFFIX})
endif()

if (WIN32 AND MSVC)
	set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS}")
	set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS}")
	set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS}")
	add_definitions(-D_CRT_SECURE_NO_WARNINGS -D_CRT_SECURE_NO_DEPRECATE=1)
	set_target_properties(pudconvert PROPERTIES LINK_FLAGS "${LINK_FLAGS}")
	set_target_properties(wartool PROPERTIES LINK_FLAGS "${LINK_FLAGS}")
endif()

########### next target ###############

configure_file (
	"${PROJECT_SOURCE_DIR}/wargus.desktop.in"
	"${PROJECT_BINARY_DIR}/wargus.desktop"
)

########### install files ###############

if(STRATAGUS_FOUND)
	install(TARGETS wargus DESTINATION ${GAMEDIR})
endif()
install(TARGETS pudconvert wartool DESTINATION ${BINDIR})
install(FILES wargus.png DESTINATION ${ICONDIR})
install(FILES "${PROJECT_BINARY_DIR}/wargus.desktop" DESTINATION ${DESKTOPDIR})

install(DIRECTORY campaigns graphics maps music scripts sounds DESTINATION ${SHAREDIR})
install(FILES contrib/red_cross.png DESTINATION ${SHAREDIR}/graphics/missiles)
install(FILES contrib/cross.png DESTINATION ${SHAREDIR}/graphics/ui/cursors)
install(FILES contrib/food.png contrib/health.png contrib/health2.png contrib/mana.png contrib/mana2.png contrib/ore,stone,coal.png contrib/score.png DESTINATION ${SHAREDIR}/graphics/ui)

=== debian/changelog ===
wargus (2.4.1-1) unstable; urgency=low

  * Compatibility with Stratagus 2.4.1
  * Updated installers for debian, windows, mac os x
  * Remove remaining maemo support code
  * Features
    - Support lua checksums and add proper error message for multiplayer
    - Make barracks selectable by rectangle
    - Commandline arguments can be passed to directly start or join multiplayer games
  * Bugfixes
    - All buttons now emit click sounds
    - Sapper demolition range increased to behave as in original game
    - Main menu music should now be correct for all supported versions
    - Remove colorcycled border
    - Disable diplomacy checkboxes for computer players
    - Remove unfinished metaserver menu
    - ToD Human mission 4 now rescues rangers, not archers

 -- Tim Felgentreff <timfelgentreff@gmail.com>  Wed, 2 Dec 2015 11:28:27 +0100

wargus (2.4.0-1) unstable; urgency=low

  * Compatibility with Stratagus 2.4
  * Updates to Timeless Tales and Frontier Force

 -- Tim Felgentreff <timfelgentreff@gmail.com>  Wed, 2 Dec 2015 11:28:27 +0100

wargus (2.3.0-1) unstable; urgency=low

  * Game
   - Merge Wargus with Aleona's Tales (if you don't have WC2 data, wargus will install AT data)
   - Support for custom game types.
   - Skirmish Modern setup screen from Doom Wars (custom colors, races, teams, AI scripts for each player)
   - Custom campaign support
   - Mod support
   - All WC2 campaigns now have unique AI scripts (similar to original ones)
   - 5 difficulty levels for campaigns (affect AI aggressiveness)
   - Added Russian translation (based on SPK translation)
   - Support for MIDI playback using FluidSynth library (and so support for custom SF2 soundfonts)
   - Imported some changes from Andrettin's WIP project
   - Result screen similar to original WC2
   - New FtM 2014 game mode (with tutorial campaigns)
   - Many improvements to the user interface: button popups, network setup, UI elements, preferences menu and a lot more.
   - ColorCycle by Tileset (patch from DinkyDyeAussie)
   - Added Frontier Force Mission 5
   - Added Tales Campaign Mission 7
   - Added town hall, lumber mill, refinery resource info on panel
   - Added icon shifting on click
   - Increased maximum game speed to 90
   - Added autocast and ai-cast information to spells (now Death Knights are able to cast Death Coil)
   - Mine low resources notifications
  * Wartool
   - Support extraction from WC2 BNE disc
   - Support extraction from Russian SPK discs (both original and expansion)
  * Bugfixes
   - Fix catapult property to allow transporter to transport catapult. - bug #1155799
   - Fix playerCount calculation in multiplayer. - bug #225514
   - Add equivalence for some missing units (farm and goblin sapper) - bug #1197963
   - Fixed Unholy Armor spell: how it works like in original WC2, also added autocast info - bug #1171017
   - Fixed incorrect critter names - bug #1196860
   - Fixed cheats - bug #1162392
   - Fixed Cho'gall spells - bug #1022645
   - Fixed bug with Fog of War disabling - bug #902658
   - Fix speed of dragon with Haste Patch from vota (rocadeier)
   - Correct handling of infopanel.png

 -- cybermind <iddqd_mail@mail.ru>  Mon, 16 Mar 2015 18:51:27 +0500

wargus (2.2.7-1) unstable; urgency=low

  * Fixed bugs
   - Link wargus executable directly with X11 library - bug #908789
   - Fixed Debian installation - bug #909017
   - Show enemy unit levels - bug #817753
   - Fix typo by replacing 'stronghol' by 'stronghold' - bug #992273
   - Added slider for configuring mouse scroll speed to options menu - bug #817089
   - Do not overwrite CMAKE_EXE_LINKER_FLAGS, make install paths configurable - bug #1005271
   - Wartool - do not crash if Warcraft WAR archives are corrupted or incomplete - bug #998584
   - Generating User Preferences file - bug #1015938
   - Fixed compilation on more platforms
   - Fixed other problems

 -- Pali Rohár <pali.rohar@gmail.com>  Mon, 20 Aug 2012 13:49:07 +0200

wargus (2.2.6-1) unstable; urgency=low

  * Game
   - Show error box if saving game/map failed
   - Added support for starting game with specified map from command line
   - Animate Gold Mine when workers mining
   - Handle errors when saving game failed
   - Fixed showing tips on startup
   - Fixed spells and upgrades
   - Reverted back Color Cycling support
   - Fixed DefinePlayerTypes - bug #736460
  * Wartool
   - Fixed all memory leaks and memory erros
   - Added support for converting videos to ogv format (using ffmpeg2theora)
   - Added support for converting music files to ogg format (using timidity and ffmpeg2theora)
   - Added support for ripping sound tracks from Audio CD (using cdda2wav or cdparanoia)
  * Makefile
   - Rewritted to CMake
  * Wargus
   - Rewritted to use Stratagus Game Launcher
  * Maemo Warextract
   - Rewritted to use Stratagus Maemo Extractor
  * Debian
   - Rewritted control files to debhelper 7
   - Fixed debconf for dpkg-reconfigure
   - Fixed lintian errors and warnings
  * Unix build.sh
   - Script was removed, all functionality moved into wartool
  * Windows NSIS Installer
   - Removed all converting processes code (moved into wartool)

 -- Pali Rohár <pali.rohar@gmail.com>  Tue, 20 Dec 2011 19:37:55 +0100

wargus (2.2.5.5-1) unstable; urgency=low

  * New upstream release

 -- Pali Rohár <pali.rohar@gmail.com>  Mon, 22 Nov 2010 22:32:45 +0100

wargus (2.2.5.4-1) unstable; urgency=low

  * New upstream release

 -- Pali Rohár <pali.rohar@gmail.com>  Mon, 20 Sep 2010 15:24:31 +0200

wargus (2.2.5.3-1) unstable; urgency=low

  * New upstream release

 -- Pali Rohár <pali.rohar@gmail.com>  Wed, 11 Aug 2010 11:00:43 +0200

wargus (2.2.5.2) unstable; urgency=low

  * New upstream release

 -- Pali Rohár <pali.rohar@gmail.com>  Tue, 27 Jul 2010 10:05:19 +0200

wargus (2.2.5-1) unstable; urgency=low

  * New upstream release

 -- M. Gerhardy <tlh2000@users.sf.net>  Sat, 23 May 2009 10:51:08 +0200

=== debian/control ===
Source: wargus
Section: games
Priority: optional
Maintainer: cybermind <iddqd_mail@mail.ru>
Build-Depends: debhelper (>= 7), cmake (>= 2.6), pkg-config, imagemagick,
 po-debconf, sharutils, zlib1g-dev, libbz2-dev, libx11-dev,
 libpng12-dev (>= 1.2.5), libhildon1-dev | libgtk2.0-dev, libbz2-dev,
 stratagus-dev
Standards-Version: 3.9.2
Homepage: https://github.com/Wargus/wargus

Package: wargus
Architecture: any
Depends: ${stratagus:Depends}, ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: cdparanoia, ffmpeg2theora
Recommends: musescore-soundfont-gm
Provides: stratagus-data
Description: Warcraft II data game set for the Stratagus engine
 Wargus can be used to play Warcraft II from Blizzard Entertainment.
 .
 You need the original Warcraft II CD to extract the game data files.
 .
 Wargus is developed together for Windows, Linux and Mac OS X.
